"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toYfmCut = exports.createYfmCut = void 0;
const prosemirror_utils_1 = require("prosemirror-utils");
const const_1 = require("../const");
const createYfmCutNode = (schema) => (content) => {
    return (0, const_1.cutType)(schema).create(null, [
        (0, const_1.cutTitleType)(schema).create(null),
        (0, const_1.cutContentType)(schema).create(null, content),
    ]);
};
const createYfmCut = (state, dispatch) => {
    const { schema } = state;
    const parent = (0, prosemirror_utils_1.findParentNodeOfType)(schema.nodes.paragraph)(state.selection);
    if (parent) {
        if (dispatch) {
            const yfmCut = createYfmCutNode(schema)(parent.node);
            dispatch === null || dispatch === void 0 ? void 0 : dispatch(state.tr.replaceWith(parent.pos, parent.pos + parent.node.nodeSize, yfmCut));
        }
        return true;
    }
    return false;
};
exports.createYfmCut = createYfmCut;
exports.toYfmCut = {
    isEnable(state) {
        return (0, exports.createYfmCut)(state);
    },
    run(state, dispatch) {
        (0, exports.createYfmCut)(state, dispatch);
    },
};
