import { findParentNodeOfType } from 'prosemirror-utils';
import { cutContentType, cutTitleType, cutType } from '../const';
const createYfmCutNode = (schema) => (content) => {
    return cutType(schema).create(null, [
        cutTitleType(schema).create(null),
        cutContentType(schema).create(null, content),
    ]);
};
export const createYfmCut = (state, dispatch) => {
    const { schema } = state;
    const parent = findParentNodeOfType(schema.nodes.paragraph)(state.selection);
    if (parent) {
        if (dispatch) {
            const yfmCut = createYfmCutNode(schema)(parent.node);
            dispatch === null || dispatch === void 0 ? void 0 : dispatch(state.tr.replaceWith(parent.pos, parent.pos + parent.node.nodeSize, yfmCut));
        }
        return true;
    }
    return false;
};
export const toYfmCut = {
    isEnable(state) {
        return createYfmCut(state);
    },
    run(state, dispatch) {
        createYfmCut(state, dispatch);
    },
};
